class Box
  @@description        = ''
  @@name               = ''
  @@download_repo      = ''
  @@download_directory = ''

  class << self
    attr_accessor :boxes
    Box.boxes = []
    attr_accessor :default_boxes
    Box.default_boxes = []
  end

  attr_accessor :name
  attr_accessor :description
  attr_accessor :download_repo
  attr_accessor :download_directory

  def install
    pre_steps
    FileManager.generate_basic_folders
    FileManager.current_box = @name
    FileManager.download_box(@download_repo)
    custom_install_steps
    FileManager.symlink_all(@name, @download_repo)
  end

  def pre_steps
  end

  def custom_install_steps
  end

  def initialize
    @download_repo = @@download_repo
    @name          = @@name
    @description   = @@description

    if @@download_directory.empty?
      @download_directory = @@download_directory
    else
      @download_directory = @name
    end

    if @name.include?('default_')
      @name = @name.gsub!('default_', '')
      Box.default_boxes << self
    end
    Box.boxes << self
  end
end